VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "classID3_V11"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'ID3 EDIT Module
'MP3  ID3 V1 nǂݍ݁AύXAۑ郂W[
'
'Copyright(c) 2004 Yuumi
'http://gochagocha.ribbon.to/
'http://gochagocha.org/
'gochagocha@ribbon.to


'ID3 Ver1.0
Private Type ID3_1
    TAG As String * 3
    TRACKNAME As String * 30
    AIRTISTNAME As String * 30
    ALBUMNAME As String * 30
    RELEASEYEAR As String * 4
    COMMENT As String * 30
    GENRE As Byte
End Type

'ID3 Ver1.1
Private Type ID3_11
    TAG As String * 3           '^O "TAG"
    TRACKNAME As String * 30    'Ȗ
    AIRTISTNAME As String * 30  '̎薼
    ALBUMNAME As String * 30    'Ao
    RELEASEYEAR As String * 4   'N
    COMMENT As String * 28      'Rg
    RESERVE As Byte             '{TRACKNOʓ|Ȃ߃U[u
    TRACKNO As Byte             'gbNԍ
    GENRE As Byte               'WID
End Type

'萔錾
Private Const ClassVersion As Integer = 100
Private Const LOADTYPE_NOOPEN As Integer = 0
Private Const LOADTYPE_WITH_TAG As Integer = 1
Private Const LOADTYPE_WITHOUT_TAG  As Integer = 2

'ϐݒ

Private MP3FileName As String
Private ErrorNo As String
Private ID3_11_Data As ID3_11

Private Function CheckMP3(ByVal CheckMp3FileName As String) As Integer
    Dim Rfn As Integer
    Dim ReadFileSize As Long
    Dim MP3Header(3) As Byte
    Dim FlagID3 As Boolean
    Dim TmpID3_11 As ID3_11
    CheckMP3 = LOADTYPE_NOOPEN
    On Error GoTo ErrorEnd
    Rfn = FreeFile(0)
    ReadFileSize = FileLen(CheckMp3FileName)
    Open CheckMp3FileName For Binary Lock Write As #Rfn
        Get #Rfn, , MP3Header
        If CheckMP3Header(MP3Header) = True Then    'MP3ǂ`FbN( ID3 VER2 ȍ~͔ے)
            FlagID3 = True
            CheckMP3 = LOADTYPE_WITH_TAG
            If ReadFileSize < Len(TmpID3_11) Then   'ID3 
                FlagID3 = False
            Else
                Seek #Rfn, ReadFileSize - Len(TmpID3_11) + 1
                Get #Rfn, , TmpID3_11
                If TmpID3_11.TAG <> "TAG" Then 'ID3 
                    FlagID3 = False
                End If
            End If
            If FlagID3 = False Then 'ID3 ZbgĂȂȂ烊Zbg
'                Call ResetID3
                CheckMP3 = LOADTYPE_WITHOUT_TAG
            End If
'            Call CheckID3
            ErrorNo = 0
        Else
            ErrorNo = 2
        End If
ErrorEnd:
    Close #Rfn
End Function

'̂蔲@Uwb_łʂ
Private Function CheckMP3Header(ByRef MP3Header() As Byte) As Boolean
    CheckMP3Header = False
    Select Case MP3Header(0)
        Case &HFF   'wb_ not over ID3 Ver2
            If (MP3Header(1) And &HF0) <> &HF0 Then 'wb_
                Exit Function
            ElseIf (MP3Header(1) And &H8) <> &H8 Then   'ID
                Exit Function
            ElseIf (MP3Header(1) And &H6) <> &H2 Then   'layer III
                Exit Function
            End If
        Case Asc("I")   'ID3 ver2?
            If MP3Header(1) <> Asc("D") Or MP3Header(2) <> Asc("3") Then
                Exit Function
            End If
        Case Else   '
            Exit Function
    End Select
    CheckMP3Header = True
End Function
Private Sub ResetID3()
    With ID3_11_Data 'V1.0  NULL ł͂Ȃ SPACE A1.1 Ή̂NULLɕύX
        .TAG = "TAG"
        .AIRTISTNAME = vbNullChar
        .ALBUMNAME = vbNullChar
        .COMMENT = vbNullChar
        .GENRE = 0
        .RELEASEYEAR = vbNullChar
        .TRACKNAME = vbNullChar
        .TRACKNO = 0
    End With
End Sub
'ID3  V1.0 Ŏw肳Ăꍇ 1.1 ɒu
Private Sub CheckID3()
    With ID3_11_Data
        .AIRTISTNAME = RightSpaceCut(.AIRTISTNAME)
        .ALBUMNAME = RightSpaceCut(.ALBUMNAME)
        .COMMENT = RightSpaceCut(.COMMENT)
        .RELEASEYEAR = RightSpaceCut(.RELEASEYEAR)
        .TRACKNAME = RightSpaceCut(.TRACKNAME)
        If .RESERVE = &H20 And .TRACKNO = &H20 Then 'V1.0
            .TRACKNO = 0
        End If
        .RESERVE = 0    'f[^폜
        If .TRACKNO > 100 Then  'dl100ȏCDɂ͖
            .TRACKNO = 0
        End If
    End With
End Sub
Private Function RightSpaceCut(ByVal checkStr As String) As String
    Dim spaceLoc As Long, LastspaceLoc As Long
    RightSpaceCut = checkStr
    Do
        LastspaceLoc = spaceLoc
        spaceLoc = InStrRev(checkStr, " ", LastspaceLoc - 1)
        If LastspaceLoc > 0 Then
            If LastspaceLoc - 1 <> spaceLoc Then
                spaceLoc = 0
            End If
        End If
    Loop While (spaceLoc > 1)
    If spaceLoc = 1 Then LastspaceLoc = 1
    If LastspaceLoc > 0 Then 'Xy[XȂ
        RightSpaceCut = IIf(LastspaceLoc > 1, Left$(checkStr, LastspaceLoc - 1), "") + vbNullChar
    End If
End Function

Private Function ReadID3Tag(ByVal Mp3File As String) As Boolean
    Dim Rfn As Integer
    Dim ReadFileSize As Long
    
    On Error GoTo ErrorEnd
    ReadID3Tag = False
    
    Select Case CheckMP3(Mp3File)
        Case LOADTYPE_WITH_TAG      'ID3 OK
            Rfn = FreeFile(0)
            ReadFileSize = FileLen(Mp3File)
            Open Mp3File For Binary Lock Write As #Rfn
                Seek #Rfn, ReadFileSize - Len(ID3_11_Data) + 1
                Get #Rfn, , ID3_11_Data
                Call CheckID3
                ReadID3Tag = True
            Close #Rfn
        Case LOADTYPE_WITHOUT_TAG   'ID3 ZbgĂȂȂ烊Zbg
            Call ResetID3
            ReadID3Tag = True
        Case LOADTYPE_NOOPEN
            Exit Function
    End Select
ErrorEnd:
    Close #Rfn
End Function

Public Property Let SetMP3File(ByVal setMP3filename As String)
    MP3FileName = setMP3filename
End Property

Public Function LoadMp3File(Optional ByVal setMP3filename As String) As Boolean
    LoadMp3File = False 'Ƃ肠ے
    If setMP3filename <> "" Then
        MP3FileName = setMP3filename
    End If
    If MP3FileName = "" Then
        ErrorNo = 1
        Exit Function
    End If
    If ReadID3Tag(MP3FileName) = False Then
        ErrorNo = 2
        Exit Function
    End If
    LoadMp3File = True
End Function

Private Function WriteID3Tag(ByVal Mp3File As String) As Boolean
    Dim Wfn As Integer
    Dim ReadFileSize As Long
    Dim MP3Header(3) As Byte
    Dim FlagID3 As Boolean
    Dim SeekPoint As Long
    
    WriteID3Tag = False
    On Error GoTo ErrorEnd
    
    ReadFileSize = FileLen(Mp3File)
    Select Case CheckMP3(Mp3File)
        Case LOADTYPE_WITH_TAG
            SeekPoint = ReadFileSize - Len(ID3_11_Data) + 1
        Case LOADTYPE_WITHOUT_TAG
            SeekPoint = ReadFileSize + 1
        Case Else
            Exit Function
    End Select
    Wfn = FreeFile(0)
    Open Mp3File For Binary Lock Write As #Wfn
        Seek #Wfn, SeekPoint
        Put #Wfn, , ID3_11_Data
        WriteID3Tag = True
ErrorEnd:
    Close #Wfn
End Function

Public Function SaveMp3File(Optional ByVal setMP3filename As String) As Boolean
    SaveMp3File = False 'Ƃ肠ے
    If setMP3filename <> "" Then
        MP3FileName = setMP3filename
    End If
    If MP3FileName = "" Then
        ErrorNo = 1
        Exit Function
    End If
    If WriteID3Tag(MP3FileName) = False Then
        ErrorNo = 2
        Exit Function
    End If
    SaveMp3File = True
End Function

'p͂[킩̂ŁAȂƂȂ
Public Property Get ErrorString() As String
    Select Case ErrorNo
        Case 0  'G[
            ErrorString = "NO ERROR"
        Case 1  't@CZbgĂȂ
            ErrorString = "FILE NOT SET"
        Case 2  't@CA͖
            ErrorString = "FILE NOT FOUND or FILE NOT MP3( ID3 over V2 NOT SUPPORT)"
        Case Else
            ErrorString = "HAPPENING"
    End Select
End Property

Private Sub Class_Initialize()
    ErrorNo = 0
End Sub

Public Property Get Version() As Integer
    Version = ClassVersion
End Property

Public Property Get GetTrackName() As String
    GetTrackName = ID3_11_Data.TRACKNAME
End Property

Public Property Get GetAirtistName() As String
    GetAirtistName = ID3_11_Data.AIRTISTNAME
End Property

Public Property Get GetAlbumName() As String
    GetAlbumName = ID3_11_Data.ALBUMNAME
End Property

Public Property Get GetReleaseYear() As String
    GetReleaseYear = ID3_11_Data.RELEASEYEAR
End Property

Public Property Get GetComment() As String
    GetComment = ID3_11_Data.COMMENT
End Property

Public Property Get GetTrackNumber() As Byte
    GetTrackNumber = ID3_11_Data.TRACKNO
End Property

Public Property Get GetGenreID() As Byte
    GetGenreID = ID3_11_Data.GENRE
End Property

Public Property Let SetTrackName(ByVal newTrackName As String)
    ID3_11_Data.TRACKNAME = newTrackName + vbNullChar
End Property

Public Property Let SetAirtistName(ByVal newAirtistName As String)
    ID3_11_Data.AIRTISTNAME = newAirtistName + vbNullChar
End Property

Public Property Let SetAlbumName(ByVal newAlbumName As String)
    ID3_11_Data.ALBUMNAME = newAlbumName + vbNullChar
End Property

Public Property Let SetReleaseYear(ByVal newReleaseYear As String)
    ID3_11_Data.RELEASEYEAR = newReleaseYear + vbNullChar
End Property

Public Property Let SetComment(ByVal newComment As String)
    ID3_11_Data.COMMENT = newComment + vbNullChar
End Property

Public Property Let SetTrackNumber(ByVal newTrackNumber As Byte)
    ID3_11_Data.TRACKNO = newTrackNumber
End Property

Public Property Let SetGenreID(ByVal newGenreID As Byte)
    ID3_11_Data.GENRE = newGenreID
End Property

'WINAMP ̃W\ł
Function GetGenreString(ByVal gID As Integer) As String
    Select Case gID
        Case 0
            GetGenreString = "Blues"
        Case 1
            GetGenreString = "Classic Rock"
        Case 2
            GetGenreString = "Country"
        Case 3
            GetGenreString = "Dance"
        Case 4
            GetGenreString = "Disco"
        Case 5
            GetGenreString = "Funk"
        Case 6
            GetGenreString = "Grunge"
        Case 7
            GetGenreString = "Hip-Hop"
        Case 8
            GetGenreString = "Jazz"
        Case 9
            GetGenreString = "Metal"
        Case 10
            GetGenreString = "New Age"
        Case 11
            GetGenreString = "Oldies"
        Case 12
            GetGenreString = "Other"
        Case 13
            GetGenreString = "Pop"
        Case 14
            GetGenreString = "R&B"
        Case 15
            GetGenreString = "Rap"
        Case 16
            GetGenreString = "Reggae"
        Case 17
            GetGenreString = "Rock"
        Case 18
            GetGenreString = "Techno"
        Case 19
            GetGenreString = "Industrial"
        Case 20
            GetGenreString = "Alternative"
        Case 21
            GetGenreString = "Ska"
        Case 22
            GetGenreString = "Death Metal"
        Case 23
            GetGenreString = "Pranks"
        Case 24
            GetGenreString = "Soundtrack"
        Case 25
            GetGenreString = "Euro-Techno"
        Case 26
            GetGenreString = "Ambient"
        Case 27
            GetGenreString = "Trip-Hop"
        Case 28
            GetGenreString = "Vocal"
        Case 29
            GetGenreString = "Jazz+Funk"
        Case 30
            GetGenreString = "Fusion"
        Case 31
            GetGenreString = "Trance"
        Case 32
            GetGenreString = "Classical"
        Case 33
            GetGenreString = "Instrumental"
        Case 34
            GetGenreString = "Acid"
        Case 35
            GetGenreString = "House"
        Case 36
            GetGenreString = "Game"
        Case 37
            GetGenreString = "Sound Clip"
        Case 38
            GetGenreString = "Gospel"
        Case 39
            GetGenreString = "Noise"
        Case 40
            GetGenreString = "AlternRock"
        Case 41
            GetGenreString = "Bass"
        Case 42
            GetGenreString = "Soul"
        Case 43
            GetGenreString = "Punk"
        Case 44
            GetGenreString = "Space"
        Case 45
            GetGenreString = "Meditative"
        Case 46
            GetGenreString = "Instrumental Pop"
        Case 47
            GetGenreString = "Instrumental Rock"
        Case 48
            GetGenreString = "Ethnic"
        Case 49
            GetGenreString = "Gothic"
        Case 50
            GetGenreString = "Darkwave"
        Case 51
            GetGenreString = "Techno-Industrial"
        Case 52
            GetGenreString = "Electronic"
        Case 53
            GetGenreString = "Pop-Folk"
        Case 54
            GetGenreString = "Eurodance"
        Case 55
            GetGenreString = "Dream"
        Case 56
            GetGenreString = "Southern Rock"
        Case 57
            GetGenreString = "Comedy"
        Case 58
            GetGenreString = "Cult"
        Case 59
            GetGenreString = "Gangsta"
        Case 60
            GetGenreString = "Top 40"
        Case 61
            GetGenreString = "Christian Rap"
        Case 62
            GetGenreString = "Pop/Funk"
        Case 63
            GetGenreString = "Jungle"
        Case 64
            GetGenreString = "Native American"
        Case 65
            GetGenreString = "Cabaret"
        Case 66
            GetGenreString = "New Wave"
        Case 67
            GetGenreString = "Psychadelic"
        Case 68
            GetGenreString = "Rave"
        Case 69
            GetGenreString = "Showtunes"
        Case 70
            GetGenreString = "Trailer"
        Case 71
            GetGenreString = "Lo-Fi"
        Case 72
            GetGenreString = "Tribal"
        Case 73
            GetGenreString = "Acid Punk"
        Case 74
            GetGenreString = "Acid Jazz"
        Case 75
            GetGenreString = "Polka"
        Case 76
            GetGenreString = "Retro"
        Case 77
            GetGenreString = "Musical"
        Case 78
            GetGenreString = "Rock & Roll"
        Case 79
            GetGenreString = "Hard Rock"
        Case 80
            GetGenreString = "Folk"
        Case 81
            GetGenreString = "Folk/Rock"
        Case 82
            GetGenreString = "National Folk"
        Case 83
            GetGenreString = "Swing"
        Case 84
            GetGenreString = "Fast-Fusion"
        Case 85
            GetGenreString = "Bebob"
        Case 86
            GetGenreString = "Latin"
        Case 87
            GetGenreString = "Revival"
        Case 88
            GetGenreString = "Celtic"
        Case 89
            GetGenreString = "Bluegrass"
        Case 90
            GetGenreString = "Avantgarde"
        Case 91
            GetGenreString = "Gothic Rock"
        Case 92
            GetGenreString = "Progressive Rock"
        Case 93
            GetGenreString = "Psychedelic Rock"
        Case 94
            GetGenreString = "Symphonic Rock"
        Case 95
            GetGenreString = "Slow Rock"
        Case 96
            GetGenreString = "Big Band"
        Case 97
            GetGenreString = "Chorus"
        Case 98
            GetGenreString = "Easy Listening"
        Case 99
            GetGenreString = "Acoustic"
        Case 100
            GetGenreString = "Humour"
        Case 101
            GetGenreString = "Speech"
        Case 102
            GetGenreString = "Chanson"
        Case 103
            GetGenreString = "Opera"
        Case 104
            GetGenreString = "Chamber Music"
        Case 105
            GetGenreString = "Sonata"
        Case 106
            GetGenreString = "Symphony"
        Case 107
            GetGenreString = "Booty Bass"
        Case 108
            GetGenreString = "Primus"
        Case 109
            GetGenreString = "Porn Groove"
        Case 110
            GetGenreString = "Satire"
        Case 111
            GetGenreString = "Slow Jam"
        Case 112
            GetGenreString = "Club"
        Case 113
            GetGenreString = "Tango"
        Case 114
            GetGenreString = "Samba"
        Case 115
            GetGenreString = "Folklore"
        Case 116
            GetGenreString = "Ballad"
        Case 117
            GetGenreString = "Power Ballad"
        Case 118
            GetGenreString = "Phythmic Soul"
        Case 119
            GetGenreString = "Freestyle"
        Case 120
            GetGenreString = "Duet"
        Case 121
            GetGenreString = "Punk Rock"
        Case 122
            GetGenreString = "Drum Solo"
        Case 123
            GetGenreString = "A Cappella"
        Case 124
            GetGenreString = "Euro-House"
        Case 125
            GetGenreString = "Dance Hall"
        Case 126
            GetGenreString = "Goa"
        Case 127
            GetGenreString = "Drum & Bass"
        Case 128
            GetGenreString = "Club-House"
        Case 129
            GetGenreString = "Hardcore"
        Case 130
            GetGenreString = "Terror"
        Case 131
            GetGenreString = "Indie"
        Case 132
            GetGenreString = "BritPop"
        Case 133
            GetGenreString = "Negerpunk"
        Case 134
            GetGenreString = "Polsk Punk"
        Case 135
            GetGenreString = "Beat"
        Case 136
            GetGenreString = "Christian Gangsta Rap"
        Case 137
            GetGenreString = "Heavy Metal"
        Case 138
            GetGenreString = "Black Metal"
        Case 139
            GetGenreString = "Crossover"
        Case 140
            GetGenreString = "Contemporary Christian"
        Case 141
            GetGenreString = "Christian Rock"
        Case 142
            GetGenreString = "Merengue"
        Case 143
            GetGenreString = "Salsa"
        Case 144
            GetGenreString = "Thrash Metal"
        Case 145
            GetGenreString = "Anime"
        Case 146
            GetGenreString = "JPop"
        Case 147
            GetGenreString = "Synthpop"
    End Select
End Function

